# FXSTAT - Run imstat on several files, one image extension at a time
# May 21, 2004
# By Doug Mink, SAO Telescope Data Center

procedure fxstat (images)

string	images=""	{prompt="Images to merge"}

string	fields="image,npix,mean,stddev,min,max" {prompt="Fields to be printed"}
bool	deltemp=yes	{prompt="Delete intermediate image files (y or n)"}
bool	verbose=yes	{prompt="Print process progress (y or n)"}

begin

int	iext
file	templist, imin
string	ims, imsec, imlist, flds
bool	vb

	vb = verbose
	ims = images
	flds = fields

	if (ims == "") {
	    print ("FXSTAT:  Run imstat on a list of images one amp at a time")
	    print ("Usage: fxstat <input images with 4 extensions>")
	    return
	    }

#  Make temporary list of input files
	templist = mktemp ("fxstatlist")
	files (ims, >templist)
	for (iext = 1; iext < 5; iext = iext + 1) {
	    imlist = ""
	    list = templist
            while (fscan (list,imin) != EOF) {

# Run imstat on each extension of each image
		if (imlist != "")
		    imlist = imlist // ","
		imlist = imlist // imin // "[" // iext // "]"
		
		}
	    imstat (imlist, fields=flds)
	    }
	if (deltemp)
	    delete (templist)
end

# June 2 2004	New program to process list of multiextension images
