# HCOUNT -- Count number of lines in a file
# By Doug Mink, SAO Telescope Date Center
# June 12, 2009

procedure hcount (filename)

file	filename = ""	{prompt="Name of file in which to count lines"}
int	nlines = 0	{prompt="Number of lines in file (returned)"}
bool	verbose=no	{prompt="Log progress (y or n)"}
bool	debug=no	{prompt="Too much info from sumspec (y or n)"}

struct	*countfile

begin
	file fn
	bool vb, db
	string line

	vb = verbose
	db = debug
	if (db)
	    vb = yes

	fn = filename
	if (fn == "") {
	    print ("HCOUNT:  Return the number of lines in a file")
	    print ("Usage: hcount <filename>")
	    return
	    }

	countfile = filename
	nlines = 0
	while (fscan (countfile, line) != EOF) {
	    nlines = nlines + 1
	    if (db)
		print (nlines,": ", line)
	    }

	if (vb)
	    print (nlines)

	countfile = ""
	return
end
# Jun 12 2009	New task
