# File hectospec/Scripts/hgain.cl
# By Doug Mink
# March 5, 2008

# Run the 4 separate gain corrections for HECTOSPEC
# Input may be a comma-separated list or a filename (with prefaced "@")
# If output list not given, the updates are in place, else the output
# list must match the input in number.

procedure hgain (input)

string input = ""	{prompt="Images to correct"}

string	g1 = "!GAIN"	{prompt="Gain for amplifier 1"}
string	g2 = "!GAIN"	{prompt="Gain for amplifier 2"}
string	g3 = "!GAIN"	{prompt="Gain for amplifier 3"}
string	g4 = "!GAIN"	{prompt="Gain for amplifier 4"}
bool	saveold=yes     {prompt="Save unprocessed image files (y or n)"}
bool    deltemp=yes     {prompt="Save single-extension files (y or n)"}
bool	verbose = yes	{prompt="verbose output (y or n)"}

struct *gainlist

begin

	string inlist
	file imin, templist
	bool sv, dt, vb

	inlist = input
	sv = saveold
	dt = deltemp
	vb = verbose
   
	templist = mktemp ("tempgain") // ".list"
	files (inlist, >templist)

	gainlist = templist
	while( fscan (gainlist, imin) != EOF) {
	    hgain1 (imin,gain1=g1,gain2=g2,gain3=g3,gain4=g4,saveold=sv,deltemp=dt,verbose=vb)
	    }

	if (dt)
	    delete (templist)

	gainlist = ""
end

# Mar  5 2008	Replacement for GAINCORR
