# File hectospec/Src/t_gettime.x
# May 21, 2004
# Main program by Doug Mink, Harvard-Smithsonian Center for Astrophysics

# T_GETTIME -- return current date and time as a string parameter

include <time.h>

define  SZ_WEEKDAY              3
define  SZ_MONTH                3
define	MAXCH	32

int procedure t_gettime()

char	dstring[MAXCH], tstring[MAXCH], fstring[MAXCH]
bool	usesec, verbose, clgetb()
long	iraf_time, clktime()
int	ihr, imin, isec, iday, imon, iyr
int	tm[LEN_TMSTRUCT]
string	weekday "SunMonTueWedThuFriSat"
string	month   "JanFebMarAprMayJunJulAugSepOctNovDec"

begin

# Get current IRAF time (seconds since 1980-01-01T0:00)
	iraf_time = 0
	iraf_time = clktime (iraf_time)

# Break up seconds into something usable
	call brktime (iraf_time, tm)
	ihr = TM_HOUR(tm)
	imin = TM_MIN(tm)
	isec = TM_SEC(tm)
	iday = TM_MDAY(tm)
	imon = TM_MONTH(tm)
	iyr = TM_YEAR(tm)

	usesec = clgetb ("usesec")
	if (usesec) {
	    call sprintf (tstring, MAXCH, "%02d:%02d:%02d")
		call pargi (ihr)
		call pargi (imin)
		call pargi (isec)
	    }
	else {
	    if (isec > 30)
		imin = imin + 1
	    if (imin > 59) {
		ihr = ihr + 1
		imin = imin - 60
		}
	    if (ihr > 23) {
		iday = iday + 1
		ihr = ihr - 24
		}
	    call sprintf (tstring, MAXCH, "%02d:%02d")
		call pargi (TM_HOUR(tm))
		call pargi (TM_MIN(tm))
	    }
	call clpstr ("time", tstring)

	call sprintf (fstring, MAXCH, "%04d-%02d-%02dT%s")
	    call pargi (iyr)
	    call pargi (imon)
	    call pargi (iday)
	    call pargstr (tstring)
	call clpstr ("fitsdate", fstring)

	call sprintf (dstring, MAXCH, "%04d-%3.3s-%02d")
	    call pargi (iyr)
	    call pargstr (month [(imon - 1) * SZ_MONTH + 1])
	    call pargi (iday)
	call clpstr ("date", dstring)

	verbose = clgetb ("verbose")
	if (verbose) {
	    call printf ("%s %s\n")
		call pargstr (dstring)
		call pargstr (tstring)
	    }
	return
end

# May 21 2004	New task
